<template>

  <div class="box p-3 md:p-5 text-xs md:text-sm space-y-4">
    <!-- <span class="text-base md:text-2xl font-semibold">
      {{ capi?.getCurrentData().viewTitle }}
    </span> -->
    <div  ref="rosterpdf">
      <FullCalendar :options='calendarOptions' ref="calendar" />
    </div>

    <div class="flex flex-col md:flex-row gap-10 justify-between items-center">
      <form @submit.prevent="filterForm.get('/roster/roster')" class="flex flex-col md:flex-row gap-2 w-full">
        <input v-model="filterForm.year" type="number" placeholder="YYYY" min="1000" max="9999"
          class="w-full md:w-auto text-base md:text-xl md:h-12 border-gray-400 rounded text-center">
        <select v-if="type === 'Overall'" v-model="filterForm.department_id"
          class="w-full md:w-auto text-base md:text-xl md:h-12 border-gray-400 rounded text-center">
          <option>All Department</option>
          <option v-for="department in departments" :value="department.id">{{ department.name }}</option>
        </select>
        <button class="action-btn h-10 md:h-12 shadow-none w-full md:w-auto">
          Filter
        </button>
      </form>
      <!-- <a :href="`/roster/roster/download`" class="text-gray-500 md:text-lg text-base text-nowrap">
        <span>DOWNLOAD</span>
        <Icon icon="fa-solid fa-download" class="ml-2"></Icon>
      </a> -->
      <button @click="download" class="text-gray-500 md:text-lg text-base text-nowrap">
        <span>DOWNLOAD</span>
        <Icon icon="fa-solid fa-download" class="ml-2"></Icon>
      </button>
    </div>
  </div>

  <!-- Dialog -->
  <dialog id="dialog" ref="dialog" class="box p-3 w-full md:w-[600px] h-full">
    <form v-if="form.date" class="h-full flex flex-col" @submit.prevent="form.post('/roster/roster'), {
      preserveScroll: true,
    }">
      <div v-if="type === 'Overall' || type === 'HOD'" class="font-semibold text-gray-700">
        <Icon icon="fa-solid fa-edit" class="mr-2"></Icon>
        <label>Manage Shift ({{ form.date.toDateString() }})</label>
      </div>
      <div v-else class="font-semibold text-gray-700">
        <label>My Shifts ({{ form.date.toDateString() }})</label>
      </div>
      <hr class="my-2 border-gray-200 border">

      <div v-if="type === 'Overall' || type === 'HOD'" class="border border-dashed border-gray-400 p-3 mb-3">
        <div class="text-base text-center text-gray-500">
          <Icon icon="fa-solid fa-running"></Icon>
          <p class="inline-block ml-3 font-bold">Leave Notice</p>
        </div>
        <div
          v-for="la in type === 'Overall' ? leaveApplications : leaveApplications.filter(la => la.user.department_staff_detail.department_id === currentUser.head_of)"
          class="mt-4 mb-4">
          <div class="flex items-center gap-2">
            <div class="text-2xl">
              <Icon icon="fa-solid fa-circle-user">
              </Icon>
            </div>
            <div class="flex-1">
              <p class="text-sm mb-0">{{ la.user.name }} ({{ la.user.role.name }})</p>
              <div class="text-xs text-gray-500 italic flex gap-3">
                <div>
                  <Icon icon="fa-solid fa-calendar"></Icon>
                  Start Date: {{ la.start_date }}
                </div>
                <div>
                  <Icon icon="fa-solid fa-calendar"></Icon>
                  End Date: {{ la.end_date }}
                </div>
              </div>
            </div>
            <div>
              <p class="text-sm font-semibold">{{ la.leave_type.type }}</p>
            </div>
          </div>
        </div>
      </div>

      <!-- Add Shifts -->
      <div class="space-y-5">
        <div v-for="(assignedShift, index) in assignedShifts.filter((as) => {
          console.log(as.date, form.date.toLocaleDateString())
          return new Date(as.date).toLocaleDateString() === form.date.toLocaleDateString()
        })
        " :class="`w-full border rounded-sm p-3 bg-opacity-20`" :style="`border-color: ${assignedShift.shift.color}; background-color: ${assignedShift.shift.color}1A;`">
          <div class="flex justify-between">
            <label :class="`block text-[${assignedShift.shift.color}] mb-2 text-base`">
              {{ assignedShift.shift.name }} ({{ assignedShift.shift.department.name }})</label>
            <div v-if="(type === 'Overall' && currentUser.role.manage_overall_roster) || type === 'HOD'">
              <button v-if="!form.delete_assigned_shifts.includes(assignedShift.id)" type="button"
                @click="() => form.delete_assigned_shifts.push(assignedShift.id)">
                <Icon icon="fa-solid fa-trash-can" class="text-gray-400"></Icon>
              </button>
              <button v-else class="text-sm text-gray-500 italic" type="button"
                @click="() => form.delete_assigned_shifts = form.delete_assigned_shifts.filter((das) => das !== assignedShift.id)">
                Marked for deletion
              </button>
            </div>
          </div>
          <div class="flex text-gray-600 text-base">
            <div class="flex-1">
              <div>
                <Icon icon="fa-solid fa-clock"></Icon>
                Time
              </div>
              <span>{{ assignedShift.shift?.start_time }} - {{ assignedShift.shift?.end_time }}</span>
            </div>
            <div class="flex-1">
              <div>
                <Icon icon="fa-solid fa-user"></Icon>
                {{ assignedShift?.user.name }}
              </div>
              <span>({{ assignedShift.user?.role.name }}) - CID {{ assignedShift.user?.cid }}</span>
            </div>
          </div>
        </div>

        <div v-if="type === 'Overall' || type === 'HOD'" v-for="(assignedShift, index) in form.assigned_shifts"
          class="w-full border border-gray-300 rounded-sm p-3 bg-gray-50">
          <div class="flex justify-between">
            <div class="mb-2 flex justify-center gap-3">
              <label class="block text-base">
                ASSIGN SHIFT
              </label>
              <input v-if="form.assigned_shifts[index].shift" type="color" :value="form.assigned_shifts[index].shift?.color" disabled>
            </div>
            <button type="button" @click="() => deleteAssignedShift(index)">
              <Icon icon="fa-solid fa-trash-can" class="text-gray-400"></Icon>
            </button>
          </div>
          <div class="mb-3">
            <label class="block mb-2 text-sm font-medium text-gray-700 ">
              Pick a shift</label>
            <multiselect v-model="form.assigned_shifts[index].shift" :multiple="false" :options="shifts" label="name"
              track-by="id"
              :customLabel="(shift) => `${shift.name} (${shift.start_time} - ${shift.end_time}) - ${shift.department.name}`">
            </multiselect>
            <div v-if="form.errors[`assigned_shifts.${index}.shift`]" class="text-error">
              {{ form.errors[`assigned_shifts.${index}.shift`] }}
            </div>
          </div>
          <div>
            <label class="block mb-2 text-sm font-medium text-gray-700 ">
              For who?</label>
            <multiselect v-model="form.assigned_shifts[index].user" :multiple="false" :options="users" label="name"
              track-by="id" :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`">
            </multiselect>
            <div v-if="form.errors[`assigned_shifts.${index}.user`]" class="text-error">
              {{ form.errors[`assigned_shifts.${index}.user`] }}
            </div>
          </div>
        </div>

        <div v-if="(type === 'Overall' && currentUser.role.manage_overall_roster) || type === 'HOD'">
          <button type="button" class="mx-auto block text-sm text-gray-500 italic" @click="addAssignedShift">Click here
            to add+</button>
        </div>
      </div>

      <div class="flex-1">
      </div>

      <div class="flex justify-end gap-3 mt-5">
        <button type="button" @click="closeModal" class="btn orange">
          Close
        </button>
        <button v-if="type === 'Overall' || type === 'HOD'" class="btn green">
          Save
        </button>
      </div>
    </form>
  </dialog>
</template>


<script setup>
import { useForm, usePage } from '@inertiajs/vue3';
import { computed, ref, watch } from 'vue';
import FullCalendar from '@fullcalendar/vue3'
import dayGridPlugin from '@fullcalendar/daygrid'
import interactionPlugin from '@fullcalendar/interaction';
import timeGridPlugin from '@fullcalendar/timegrid'
import jsPDF from 'jspdf';
import html2canvas from 'html2canvas';

const props = defineProps({
  users: Array,
  departments: Array,
  shifts: Array,
  assignedShifts: Array,
  year: Number,
  department: Number,
  leaveApplications: Array,
  type: String
})

const filterForm = useForm({
  year: props.year,
  department_id: props.department ?? 'All Department',
})

const year = new Date();
const calendarOptions = computed(() => ({
  plugins: [dayGridPlugin, interactionPlugin, timeGridPlugin],
  initialView: 'dayGridMonth',
  headerToolbar: {
    left: 'dayGridMonth,timeGridWeek,timeGridDay',
    center: 'title',
    right: 'prev,next,today'
  },
  showNonCurrentDates: false,
  events: props.assignedShifts.map((as) => ({
    title: `${as.shift?.name} (${as.user?.name})`,
    start: `${as.date}T${as.shift?.start_time}`,
    end: `${as.date}T${as.shift?.end_time}`,
    color: as.shift.color
  })),
  initialDate: new Date(props.year, year.getMonth(), year.getDate()),
  validRange: {
    start: `${props.year}-01-01`,
    end: `${props.year}-12-32`
  },
  buttonText: {
    today: 'Now',
    month: 'M',
    week: 'W',
    day: 'D',
    list: 'list'
  },
  titleFormat: { year: 'numeric', month: 'short' },
  dateClick: function (info) {
    form.date = new Date(info.dateStr)
    dialog.value.showModal()
  }
}))

const page = usePage();
const currentUser = computed(() => page.props.currentUser)

const calendar = ref();
const rosterpdf = ref();
const dialog = ref(null);

const capi = computed(() => calendar.value?.getApi())

watch(() => page.props.expanded, (value) => {
  setTimeout(() => {
    capi.value.updateSize()
  }, 500);
})

watch(() => page.props, (value) => {
  if (value.flash.success) {
    closeModal()
  }
})

const form = useForm({
  assigned_shifts: [],
  delete_assigned_shifts: [],
  date: null
})

function addAssignedShift() {
  form.assigned_shifts.push({
    user: null,
    shift: null
  })
}

function deleteAssignedShift(index) {
  form.assigned_shifts.splice(index, 1);
}

function closeModal() {
  dialog.value.close()
  form.reset()
}

function download() {
  const element = rosterpdf.value; // Access the element with ref="xx"
  
  html2canvas(element, { scale: 1 }).then(canvas => {
    const imgData = canvas.toDataURL('image/png');
    const pdf = new jsPDF({
      orientation: 'l', // 'p' for portrait, 'l' for landscape
      unit: 'px',
      format: [element.clientWidth + 100, element.clientHeight + 100]
    });
    
    pdf.addImage(imgData, 'PNG', 50, 50, element.clientWidth, element.clientHeight);
    pdf.save('roster.pdf');
  });
}
</script>

<style scoped>

.fc-title {
  font-size: 2px !important;
}
</style>